/*
 * csp_conv_rgb_to_rgb.h
 *
 */

#ifndef CSP_CONV_RGB_TO_RGB_H
#define CSP_CONV_RGB_TO_RGB_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

void csp_rgb24_to_rgb24 (uint8_t *rgb24[], uint8_t *dst[],
	  int rgb24_stride[], int dst_stride[], int width, int height);

void csp_rgb24_to_bgr24 (uint8_t *rgb24[], uint8_t *bgr24[],
	  int rgb24_stride[], int bgr24_stride[], int width, int height);

void csp_rgb24_to_argb32 (uint8_t *rgb24[], uint8_t *argb32[],
	  int rgb24_stride[], int argb32_stride[], int width, int height);

void csp_rgb24_to_bgra32 (uint8_t *rgb24[], uint8_t *bgra32[],
	  int rgb24_stride[], int bgra32_stride[], int width, int height);

void csp_rgb24_to_rgb565 (uint8_t *rgb24[], uint8_t *rgb565[],
	  int rgb24_stride[], int rgb565_stride[], int width, int height);

void csp_rgb24_to_rgb555 (uint8_t *rgb24[], uint8_t *rgb555[],
	  int rgb24_stride[], int rgb555_stride[], int width, int height);


void csp_bgr24_to_bgr24 (uint8_t *bgr24[], uint8_t *dst[],
	  int rgb24_stride[], int dst_stride[], int width, int height);

void csp_bgr24_to_rgb24 (uint8_t *bgr24[], uint8_t *rgb24[],
	  int bgr24_stride[], int rgb24_stride[], int width, int height);

void csp_bgr24_to_argb32 (uint8_t *rgb24[], uint8_t *argb32[],
	  int rgb24_stride[], int argb32_stride[], int width, int height);

void csp_bgr24_to_bgra32 (uint8_t *rgb24[], uint8_t *bgra32[],
	  int rgb24_stride[], int bgra32_stride[], int width, int height);



void csp_argb32_to_bgra32 (uint8_t *src_rgb[], uint8_t *dst_rgb[],
              int src_stride[], int dst_stride[], int width, int height);

void csp_argb32_to_argb32 (uint8_t *src_rgb[], uint8_t *dst_rgb[],
              int src_stride[], int dst_stride[], int width, int height);


void csp_bgra32_to_argb32 (uint8_t *src_rgb[], uint8_t *dst_rgb[],
              int src_stride[], int dst_stride[], int width, int height);

void csp_bgra32_to_bgra32 (uint8_t *src_rgb[], uint8_t *dst_rgb[],
              int src_stride[], int dst_stride[], int width, int height);


#ifdef ARCH_X86

void csp_argb32_to_argb32_mmxext (uint8_t *src_rgb[], uint8_t *dst_rgb[],
              int src_stride[], int dst_stride[], int width, int height);


void csp_bgra32_to_bgra32_mmxext (uint8_t *src_rgb[], uint8_t *dst_rgb[],
              int src_stride[], int dst_stride[], int width, int height);

#endif /* ARCH_X86 */


#endif /* CSP_CONV_RGB_TO_RGB_H */

