/*
 * csp_conv_yuv_to_rgb.h
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifndef CSP_CONV_YUV_TO_RGB_H
#define CSP_CONV_YUV_TO_RGB_H

#include <inttypes.h>

void csp_yuv_to_argb32_init(void);
void csp_yuv_to_argb32_quit(void);
void csp_yuv420_to_argb32 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_argb32 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_argb32 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

void csp_yuv_to_rgb24_init(void);
void csp_yuv_to_rgb24_quit(void);
void csp_yuv420_to_rgb24 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb24 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb24 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

void csp_yuv_to_rgb565_init(void);
void csp_yuv_to_rgb565_quit(void);
void csp_yuv420_to_rgb565 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb565 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb565 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

void csp_yuv_to_rgb555_init(void);
void csp_yuv_to_rgb555_quit(void);
void csp_yuv420_to_rgb555 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb555 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb555 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

void csp_yuv_to_bgra32_init(void);
void csp_yuv_to_bgra32_quit(void);
void csp_yuv420_to_bgra32 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgra32 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgra32 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

void csp_yuv_to_bgr24_init(void);
void csp_yuv_to_bgr24_quit(void);
void csp_yuv420_to_bgr24 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr24 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr24 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

void csp_yuv_to_bgr565_init(void);
void csp_yuv_to_bgr565_quit(void);
void csp_yuv420_to_bgr565 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr565 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr565 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

void csp_yuv_to_bgr555_init(void);
void csp_yuv_to_bgr555_quit(void);
void csp_yuv420_to_bgr555 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr555 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr555 (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

#ifdef ARCH_X86

//void csp_yuv_to_argb32_init_mmx(void);
//void csp_yuv_to_argb32_quit_mmx(void);
void csp_yuv420_to_argb32_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_argb32_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_argb32_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_rgb24_init_mmx(void);
//void csp_yuv_to_rgb24_quit_mmx(void);
void csp_yuv420_to_rgb24_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb24_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb24_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_rgb565_init_mmx(void);
//void csp_yuv_to_rgb565_quit_mmx(void);
void csp_yuv420_to_rgb565_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb565_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb565_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_rgb555_init_mmx(void);
//void csp_yuv_to_rgb555_quit_mmx(void);
void csp_yuv420_to_rgb555_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb555_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb555_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgra32_init_mmx(void);
//void csp_yuv_to_bgra32_quit_mmx(void);
void csp_yuv420_to_bgra32_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgra32_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgra32_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgr24_init_mmx(void);
//void csp_yuv_to_bgr24_quit_mmx(void);
void csp_yuv420_to_bgr24_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr24_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr24_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgr565_init_mmx(void);
//void csp_yuv_to_bgr565_quit_mmx(void);
void csp_yuv420_to_bgr565_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr565_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr565_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgr555_init_mmx(void);
//void csp_yuv_to_bgr555_quit_mmx(void);
void csp_yuv420_to_bgr555_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr555_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr555_mmx (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_argb32_init_mmxext(void);
//void csp_yuv_to_argb32_quit_mmxext(void);
void csp_yuv420_to_argb32_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_argb32_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_argb32_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_rgb24_init_mmxext(void);
//void csp_yuv_to_rgb24_quit_mmxext(void);
void csp_yuv420_to_rgb24_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb24_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb24_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_rgb565_init_mmxext(void);
//void csp_yuv_to_rgb565_quit_mmxext(void);
void csp_yuv420_to_rgb565_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb565_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb565_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_rgb555_init_mmxext(void);
//void csp_yuv_to_rgb555_quit_mmxext(void);
void csp_yuv420_to_rgb555_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_rgb555_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_rgb555_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgra32_init_mmxext(void);
//void csp_yuv_to_bgra32_quit_mmxext(void);
void csp_yuv420_to_bgra32_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgra32_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgra32_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgr24_init_mmxext(void);
//void csp_yuv_to_bgr24_quit_mmxext(void);
void csp_yuv420_to_bgr24_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr24_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr24_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgr565_init_mmxext(void);
//void csp_yuv_to_bgr565_quit_mmxext(void);
void csp_yuv420_to_bgr565_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr565_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr565_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

//void csp_yuv_to_bgr555_init_mmxext(void);
//void csp_yuv_to_bgr555_quit_mmxext(void);
void csp_yuv420_to_bgr555_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv422_to_bgr555_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);
void csp_yuv444_to_bgr555_mmxext (uint8_t *yuv_planes[], uint8_t *rgb[],
              int yuv_stride[], int rgb_stride[], int width, int height);

#endif

#endif /* CSP_CONV_YUV_TO_RGB_H */

