/*
 * csp_conv_yuv_to_yuv.h
 *
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#ifndef CSP_CONV_YUV_TO_YUV_H
#define CSP_CONV_YUV_TO_YUV_H


void csp_yuv420_to_yuv420 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuv420_to_i420 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuv420_to_yv12 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_yuv420 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_i420 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_yv12 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);



void csp_yuv422_to_yuv422 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuv422_to_yuy2 (uint8_t *yuv422_planes[], uint8_t *yuy2_planes[],
	  int yuv422_stride[], int yuy2_stride[], int width, int height);

void csp_yuv422_to_uyvy (uint8_t *yuv422_planes[], uint8_t *uyvy_planes[],
	  int yuv422_stride[], int uyvy_stride[], int width, int height);

void csp_yuy2_to_yuv422 (uint8_t *yuy2_planes[], uint8_t *yuv422_planes[],
	  int yuy2_stride[], int yuv422_stride[], int width, int height);

void csp_yuy2_to_yuy2 (uint8_t *src_planes[], uint8_t *dst_planes[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuy2_to_uyvy (uint8_t *yuy2_planes[], uint8_t *uyvy_planes[],
	  int yuy2_stride[], int uyvy_stride[], int width, int height);

void csp_uyvy_to_yuv422 (uint8_t *uyvy_planes[], uint8_t *yuv422_planes[],
	  int uyvy_stride[], int yuv422_stride[], int width, int height);

void csp_uyvy_to_uyvy (uint8_t *src_planes[], uint8_t *dst_planes[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_uyvy_to_yuy2 (uint8_t *uyvy_planes[], uint8_t *yuy2_planes[],
	  int uyvy_stride[], int yuy2_stride[], int width, int height);



void csp_yuv444_to_yuv444 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#ifdef ARCH_X86

void csp_yuv420_to_yuv420_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuv420_to_i420_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuv420_to_yv12_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_yuv420_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_i420_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_yv12_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);


void csp_yuv422_to_yuv422_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuv422_to_yuy2_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuv422_to_uyvy_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuy2_to_yuv422_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuy2_to_yuy2_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yuy2_to_uyvy_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_uyvy_to_yuv422_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_uyvy_to_uyvy_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_uyvy_to_yuy2_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);



void csp_yuv444_to_yuv444_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#endif /* ARCH_X86 */

#endif /* CSP_CONV_YUV_TO_YUV_H */

