/*
 * csp_conv_yv12_to_rgb.h
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include <string.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


void csp_yv12_to_argb32 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_rgb24 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_rgb565 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_rgb555 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgra32 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgr24 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgr565 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgr555 (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#ifdef ARCH_X86

void csp_yv12_to_argb32_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#if 0
void csp_yv12_to_rgb24_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);
#endif

void csp_yv12_to_rgb565_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_rgb555_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgra32_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#if 0
void csp_yv12_to_bgr24_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);
#endif

void csp_yv12_to_bgr565_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgr555_mmxext (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);


void csp_yv12_to_argb32_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#if 0
void csp_yv12_to_rgb24_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);
#endif

void csp_yv12_to_rgb565_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_rgb555_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgra32_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#if 0
void csp_yv12_to_bgr24_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);
#endif

void csp_yv12_to_bgr565_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

void csp_yv12_to_bgr555_mmx (uint8_t *src[], uint8_t *dst[],
	  int src_stride[], int dst_stride[], int width, int height);

#endif /* ARCH_X86 */

