/*
 * yuv_to_rgb.h
 */

/*
 * yuv2rgb.c
 * Copyright (C) 2000-2002 Michel Lespinasse <walken@zoy.org>
 * Copyright (C) 1999-2000 Aaron Holtzman <aholtzma@ess.engr.uvic.ca>
 *
 * This file is part of mpeg2dec, a free MPEG-2 video stream decoder.
 * See http://libmpeg2.sourceforge.net/ for updates.
 *
 * mpeg2dec is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * mpeg2dec is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef YUV_TO_RGB_H
#define YUV_TO_RGB_H


#include <inttypes.h>


typedef struct {
  void ** table_rV;
  void ** table_gU;
  int  *  table_gV;
  void ** table_bU;
  void *  table;
} YUV_to_RGB_Tables;


#define YUV_TO_RGB_MODE_RGB   1
#define YUV_TO_RGB_MODE_BGR   2
#define YUV_TO_RGB_MODE_ARGB  3
#define YUV_TO_RGB_MODE_BGRA  4
int yuv_to_rgb_init_table(int order, int bpp, YUV_to_RGB_Tables *tables_ret);

void yuv_to_rgb32_quit(void);
void yuv_to_rgb24_quit(void);
void yuv_to_rgb565_quit(void);
void yuv_to_rgb555_quit(void);


#endif /* YUV_TO_RGB_H */

