/* get_cur_u_time_t.h */

#ifndef GET_CUR_U_TIME_H
#define GET_CUR_U_TIME_H

#include <sys/time.h>

#define U_TIME_SECOND    (1000000)

typedef unsigned long long u_time_t;

static inline u_time_t get_cur_u_time (void)
{
  struct timeval tv;

  if (gettimeofday(&tv, 0) < 0) {
    perror("get_cur_u_time");
    return 0;
  }
  return (((u_time_t)tv.tv_sec) * U_TIME_SECOND) + ((u_time_t)tv.tv_usec);
}

#endif /* GET_CUR_U_TIME_H */

