/* vframe_mgr.h */

#ifndef VFRAME_MGR_H
#define VFRAME_MGR_H

#include <inttypes.h>
#include <pthread.h>

#include "vframe.h"


typedef struct {
  pthread_mutex_t mutex;
  int32_t width, height;
  int32_t horz_border, vert_border;
  int32_t csp;
  int32_t buf_size;
  int32_t plane_size[3];
  int32_t plane_offset[3];
  int32_t stride[3];

  uint32_t last_frame_alloc_count;
  uint32_t max_last_frame_alloc_count;
//  int max_last_ext_frame_alloc_count;
  int max_frame_num;
  int max_ext_frame_num;

  int alloc_frame_num;
  int alloc_ext_frame_num;
  int free_frame_num;
  int used_frame_num;

  vframe_chain_t free_chain;
} vframe_mgr_t;

#define VFRAME_MGR_OK         0
#define VFRAME_MGR_FAIL      -1

vframe_t* vframe_mgr_get_vframe(vframe_mgr_t *vfrm_mgr);
vframe_t* vframe_mgr_get_ext_vframe(vframe_mgr_t *vfrm_mgr);
int vframe_mgr_add_free_frame(vframe_mgr_t *vfrm_mgr, vframe_t *vfrm);

vframe_mgr_t* vframe_mgr_init(int width, int height,
    int horz_border, int vert_border, int csp, int max_frame_num);
int vframe_mgr_quit(vframe_mgr_t *vfrm_mgr);

#endif /* VFRAME_MGR_H */

